Package ec.select

# Class SigmaScalingSelection

java.lang.Object
ec.BreedingSource
ec.SelectionMethod
ec.select.FitProportionateSelection
ec.select.SigmaScalingSelection

All Implemented Interfaces:
  `Prototype`, `Setup`, `RandomChoiceChooserD`, `Serializable`, `Cloneable`

public class SigmaScalingSelection extends FitProportionateSelection
Similar to FitProportionateSelection, but with adjustments to scale up/exaggerate differences in fitness for selection when true fitness values are very close to eachother across the population. This addreses a common problem with FitProportionateSelection wherein selection approaches random selection during late runs when fitness values do not differ by much.

Like FitProportionateSelection this is not appropriate for steady-state evolution. If you're not familiar with the relative advantages of selection methods and just want a good one, use TournamentSelection instead. Not appropriate for multiobjective fitnesses.

Note: Fitnesses must be non-negative. 0 is assumed to be the worst fitness.

Typical Number of Individuals Produced Per `produce(...)` call
Always 1.

Parameters

base.`scaled-fitness-floor` double = some small number (defaults to 0.1) | (The sigma scaling formula sometimes returns negative values. This is unacceptable for fitness proportionate style selection so we must substitute the fitnessFloor (some value >= 0) for the sigma scaled fitness when that sigma scaled fitness invalid input: '<'= fitnessFloor.)

Default Base
select.sigma-scaling

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `P_SCALED_FITNESS_FLOOR`
  Scaled fitness floor
  `static final String`
  `P_SIGMA_SCALING`
  Default base

  ### Fields inherited from class ec.select.FitProportionateSelection

  `fitnesses, P_FITNESSPROPORTIONATE`

  ### Fields inherited from class ec.SelectionMethod

  `INDS_PRODUCED, KEY_PARENTS`

  ### Fields inherited from class ec.BreedingSource

  `NO_PROBABILITY, P_PROB, probability`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SigmaScalingSelection()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Parameter`
  `defaultBase()`
  Returns the default base for this prototype.
  `void`
  `prepareToProduce(EvolutionState s, int subpopulation, int thread)`
  A default version of prepareToProduce which does nothing.
  `void`
  `setup(EvolutionState state, Parameter base)`
  Sets up the BreedingPipeline.

  ### Methods inherited from class ec.select.FitProportionateSelection

  `finishProducing, produce`

  ### Methods inherited from class ec.SelectionMethod

  `produce, produces, produceWithoutCloning, typicalIndsProduced`

  ### Methods inherited from class ec.BreedingSource

  `clone, fillStubs, getProbability, pickRandom, preparePipeline, setProbability, setupProbabilities`

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### P_SIGMA_SCALING

    public static final String P_SIGMA_SCALING
    Default base
    See Also:
      - Constant Field Values

  - ### P_SCALED_FITNESS_FLOOR

    public static final String P_SCALED_FITNESS_FLOOR
    Scaled fitness floor
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### SigmaScalingSelection

    public SigmaScalingSelection()

- ## Method Details

  - ### defaultBase

    public Parameter defaultBase()
    Description copied from interface: `Prototype`
    Returns the default base for this prototype. This should generally be implemented by building off of the static base() method on the DefaultsForm object for the prototype's package. This should be callable during setup(...).
    Specified by:
      `defaultBase` in interface `Prototype`
    Overrides:
      `defaultBase` in class `FitProportionateSelection`

  - ### setup

    public void setup(EvolutionState state, Parameter base)
    Description copied from class: `BreedingSource`
    Sets up the BreedingPipeline. You can use state.output.error here because the top-level caller promises to call exitIfErrors() after calling setup. Note that probability might get modified again by an external source if it doesn't normalize right.

    The most common modification is to normalize it with some other set of probabilities, then set all of them up in increasing summation; this allows the use of the fast static BreedingSource-picking utility method, BreedingSource.pickRandom(...). In order to use this method, for example, if four breeding source probabilities are {0.3, 0.2, 0.1, 0.4}, then they should get normalized and summed by the outside owners as: {0.3, 0.5, 0.6, 1.0}.

    Specified by:
      `setup` in interface `Prototype`
    Specified by:
      `setup` in interface `Setup`
    Overrides:
      `setup` in class `BreedingSource`
    See Also:
      - `Prototype.setup(EvolutionState,Parameter)`

  - ### prepareToProduce

    public void prepareToProduce(EvolutionState s, int subpopulation, int thread)
    Description copied from class: `SelectionMethod`
    A default version of prepareToProduce which does nothing.
    Overrides:
      `prepareToProduce` in class `FitProportionateSelection`